/*

Program...: Flash5SocketServer.java
Programmer: Michael Thomas - thomasma@us.ibm.com


Updates:


*/

import java.awt.event.*;
import java.util.*;
import java.awt.*;
import java.io.*;
import java.net.*;

//############################################################################################
public class Flash5SocketServer {
//############################################################################################
  
  private final String STRVERSIONSERVER = "1.0.0";  //Version of SocketServer program.

  private ServerSocket server = null;
  
//-------------------------------------------------------------------------------------
public Flash5SocketServer(int intPort) {
//-------------------------------------------------------------------------------------
  startServer( intPort );
}

//-------------------------------------------------------------------------------------  
public static void main(String args[]) {
//-------------------------------------------------------------------------------------
   
    String strPort = "8888";
    int    intPort = 0;
    
    try {
      if ( args[0] != null )   {
        intPort = Integer.parseInt( args[0] );
      	if ( intPort < 1024 ) {
      		System.out.println("Flash5 Socket Server: It is suggested that you use a port # > 1024");
      	} 
      }
    
    } catch ( Exception e ) {
      //Do nothing.  	  
  	}
    
    Flash5SocketServer objFlash5SocketServer = new Flash5SocketServer( intPort ); 
    

  }//Main

  
//-------------------------------------------------------------------------------------
private void startServer(int intPort) {      
//-------------------------------------------------------------------------------------

  try {

    ServerSocket server = new ServerSocket( intPort );

    System.out.println("###########################################");
    System.out.println("Flash5 Socket Server:  Listening to Port: " + intPort + ".  Version = " + this.STRVERSIONSERVER );
    System.out.println("###########################################");

    while( true ) {
    	
      System.out.println("### Server:  server.accept() - Listening for a new client.");
      Socket objSocket = server.accept();
      
      System.out.println("### Server:  Instantiating a new client.");
      Flash5SocketClient client = new Flash5SocketClient(objSocket);

      System.out.println("### Server:  clent.start() - Starting client.");
      client.start(); //Waits for a client.


    }

  } catch(IOException ioe) {
    System.out.println("### Server: Error - Server has stoped.");
  } 
}
  
  
}//End of Class
//EOF